//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Das005.h"
#include <stdio.h>
#include <windows.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TModDas005 *ModDas005;


HANDLE TheLib;

#include "io.h"

PORTOUT OutPort;
PORTIN InPort;
ISDRIVERINSTALLED IsDriverInstalled;

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
__fastcall TModDas005::TModDas005(TComponent* Owner)
    : TDataModule(Owner)
{
}

//Data Variables defining I/O
char DAQNAME[20];
int NUM_AIP, NUM_AOP,NUM_DIP, NUM_DOP;

long int gSpeed;

int iErr;
int gInputV, gMeasureV, gOffSetV;
FARPROC Inp3,Out3;

void _fastcall TModDas005::UnloadIODLL() {
	FreeLibrary(TheLib);
}

void _fastcall TModDas005::SetupDLL()
{
    TheLib=LoadLibrary("io.dll");
    if (TheLib==NULL) {
        ShowMessage("ERROR IO Library Not Loaded");
        }
	IsDriverInstalled = (ISDRIVERINSTALLED)GetProcAddress(TheLib,"IsDriverInstalled");
    InPort=(PORTIN)GetProcAddress(TheLib,"PortIn");
    OutPort=(PORTOUT)GetProcAddress(TheLib,"PortOut");
    IsDriverInstalled;
}


void  __fastcall TModDas005::AWait(long Speed)
{
long i;
float rl;
        //This procedure is a simple delay
        rl = 1;
        for (i = 0;i<Speed;i++) {
            rl=rl+ (5.67*89.9/5.67 + (float)i);

        	}
}

int  __fastcall TModDas005::GetSpeed()
{
    return(gSpeed);
}

float __fastcall TModDas005::FindPCSpeed()
{
TDateTime Date1,Date2,dDiff;
float rj, rl,Delay;
unsigned short hr,min,sec,ms1,ms2;
int diff;

long i, j;
    //This routine finds the relative speed of the PC and
    //places it into the global variable gSpeed%
    //This variable is used in the timing to read and write
    //to the ADC
    //This routine should be the first called

    j = 1000;
    rl=0;
    do {
       j = j * 10;
       Date1=Now();  //* Gets system time
       Date1.DecodeTime(&hr,&min,&sec,&ms1);
       for (i = 1;i<j;i++) {
         rl=rl+ (5.67*89.9/5.67 + (float)i);
       	}
       Date2=Now(); // Gets system time
       Date2.DecodeTime(&hr,&min,&sec,&ms2);
       if (ms2>=ms1) diff=ms2-ms1;
       else diff=1000+ms2-ms1;
 	   } while (diff<100);
    //MsgBox "TV=" & Str(tv) & " TV1=" & Str(tv1)
    rj=j;
    rj = 2000 * rj / ((float)(diff)); //Test will last approx two seconds
    j=(int)rj;
    Date1=Now();  //* Gets system time
    Date1.DecodeTime(&hr,&min,&sec,&ms1);
    rl=0;
    for (i = 1;i<j;i++) {
         rl=rl+ (5.67*89.9/5.67 + (float)i);
    	}
    Date2=Now(); // Gets system time
    Date2.DecodeTime(&hr,&min,&sec,&ms2);
    dDiff=Date2-Date1;
    dDiff.DecodeTime(&hr,&min,&sec,&ms1);
    diff=sec*1000+ms1;
    Delay = rj / ((float)(diff)/1000);
    if (Delay > 500000) {  //Each clk cycle for the ADC with be >4usec period
        gSpeed =(int)( 0.000002 * Delay + 1);
        }
    else {
        gSpeed = 1;
        }

    gSpeed = gSpeed * 3;
    return(Delay);
}

void __fastcall TModDas005::InitPrinterPort(Word LPTNo, Word LPTPortAdd)
{
// The function InitPrinterPort initialises the printer port used to control
// the DAQ.
// "LPTNo" is the number of the printer port 1 to 2
// "LPTPortAdd" if it is non zero the LPTNo is ignored and the value of
// LPTPortAdd is used as the base address
// if "LPTNo" is out of range "IErr%" is set to non-zero.

    iErr = 0;
    if (LPTPortAdd == 0) {
        switch(LPTNo) {
            case 1:
                 LPTData = 0x378;
                 break;
            case 2:
                 LPTData = 0x278;
                 break;
            default:
                 iErr = 1;
                 break;
            }
        }
    else {
        LPTData = LPTPortAdd;
        }
    if (iErr == 0) {
        LPTStatus = LPTData + 1;
        LPTControl = LPTData + 2;
        DataReg = 0;
        ControlReg = 0x0A;    //### was hfa Strobe and Init low Autofd high */
        Out32(LPTControl, ControlReg);
        }
}

int __fastcall TModDas005::InterrogateADC_DAS005(int iChanMode, int Channel)
{
//Note the functions FindPCSpeed and InitPrinterPort
// must be called once before this function can be called.
// This function reads the MAX186 ADC and is called from the ReadAIP_DAS005 function
// if ChanMode=0 then it is a differential reading and
//    Channel can be 1 to 4.
//       Channel 1=ADC inputs 1 & 2
//       Channel 2=ADC inputs 3 & 4
//       Channel 3=ADC inputs 5 & 6
//       Channel 4=ADC inputs 7 & 8
// if ChanMode=1 then it is a single ended reading and
//       Channel can be 1 to 8 where the ADC input is the same as the
//       Channel number.
// if ChanMode or Channel is outside these ranges IErr% is returned as
//    a non zero value.
int iWord, i,iChanM;
int iBit, iMask;
    iErr = 0;
    iWord=0;
    Out32(LPTData, 0);                //SCLK Low, DIN Low */
    AWait(gSpeed);
    ControlReg = ControlReg & 0x0FD;
    Out32(LPTControl, ControlReg); //CS Low
    switch(iChanMode) {
        case 1:
            if ((Channel < 0) || (Channel > 8)) {
                iErr = 1;
            	}
            break;
        case 0:
            if ((Channel < 0) || (Channel > 4)) {
                iErr = 1;
            	}
            break;
        default:
            iErr = 1;
            break;
        }
    Channel = Channel - 1;
    if (iChanMode == 1) {
        iBit = Channel & 0x01;
        if (iBit != 0) {
            iWord = iWord | 0x04;
        	}
        iBit = Channel & 2;
        if (iBit != 0) {
            iWord = iWord | 1;
        	}
        iBit = Channel & 4;
        if (iBit != 0) {
            iWord = iWord | 2;
        	}
        }
    else  {
        iWord = Channel;
    	}
    iWord = iWord * 16;
    iChanM = iChanMode * 4;
    iWord = iWord | iChanM;
    iWord = iWord | 0x08A;
    //Print "Control Word=", Word%

    ControlReg = ControlReg | 2;
    Out32(LPTData, 0);         //SCLK Low, DIN Low */
    Out32(LPTControl, ControlReg);     //Bring CS Low */
    iMask = 0x080;
    for (i = 0;i<=7;i++) {        // send the control word */
        iBit = iWord & iMask;
        if (iBit != 0) {
            Out32(LPTData, 2);    //CS Low SCLK Low, DIN High */
            AWait(gSpeed);
            Out32(LPTData, 3);    //CS High SCLK High, DIN High */
            AWait(gSpeed);
            }
        else {
            Out32(LPTData, 0);     //CS Low SCLK Low, DIN Low */
            AWait(gSpeed);
            Out32(LPTData, 1);     //CS High SCLK High, DIN Low */
            AWait(gSpeed);
            }

        iMask = iMask / 2;
        }

    Out32(LPTData, 0);           //CS Low SCLK Low, DIN Low */
    AWait(20 * gSpeed); 			//Wait for the conversion to be finished
    iWord = 0;
    for (i = 0; i<=11; i++) {
        iWord = iWord * 2;
        Out32(LPTData, 0x01);	//Bring Clk High                                                         'Bring Clk High */
        AWait(gSpeed);
        Out32(LPTData, 0);       //Bring Clk Low
        AWait(gSpeed);
        iBit = Inp32(LPTStatus); //read ADC's Data Out

        iBit = iBit & 0x08;
        if (iBit != 0) {
            iWord = iWord | 1;
        	}
    	}
    ControlReg = ControlReg & 0x0FD;
    Out32(LPTControl, ControlReg);   //Bring CS High */
    return(iWord);

}

int __fastcall TModDas005::ReadAIP_DAS005(int sd, int chan)
{
//Function which reads an analog input
//Note the functions FindPCSpeed & InitPrinterPort
//must be called once before this function can be called.
int Reading1, Reading2;
    if (sd == 0) {
    	//it is a differential reading so it does
    	//2 single ended channels & subtracts the difference
        Reading1 = InterrogateADC_DAS005(1, chan * 2 - 1);
        Reading2 = InterrogateADC_DAS005(1, chan * 2);
        Reading1 = Reading1 - Reading2;
        }
    else   {
    	 //it is a single ended reading
        Reading1 = InterrogateADC_DAS005(1, chan);
    	}
    if (chan==4) {
        Reading2=344;
        }
    return(Reading1);
}

int __fastcall TModDas005::ReadDips_DAS005()
{
// The ReadAllDips function reads the four digital inputs 1-4
// & returns then as an integer with a value of 0 to 15
// depending on the state of the inputs
// Note the Function InitPrinterPort must be called at the
// start of the program before this function can be used
int i, IP;
        Out32(LPTData, gDOP);
        ControlReg = ControlReg & 0x0FE; //bring strobe low then high to latch the inputs
        Out32(LPTControl, ControlReg);
        ControlReg = ControlReg | 0x01;
        Out32(LPTControl, ControlReg);
        i = Inp32(LPTStatus);
        IP = i ^ 0x080; 				//invert the busy signal
        IP = IP & 0x0F0;
        IP = IP / 16;
        return(IP);
}


int __fastcall TModDas005::ReadDIP_DAS005(int IONum)
{
// The ReadDip function reads the state of a single digital input
// The number of the input is in "IONum" & can have a value of 1 to 4
// if IONum is not in the range of 1 to 4 then IErr is set to non zero
// Note the Function InitPrinterPort must be called at the
// start of the program before this function can be used
int i, IP, iMask, iBit;
    iErr = 0;
    if ((IONum < 1) || (IONum > 4)) {
        iErr = 1;
        }

    if (iErr == 0) {
        Out32(LPTData, gDOP);
        ControlReg = ControlReg & 0x0FE; //bring strobe low then high to latch the inputs
        Out32(LPTControl, ControlReg);
        ControlReg = ControlReg | 0x01;
        Out32(LPTControl, ControlReg);
        i = Inp32(LPTStatus);
        IP = i ^ 0x080;          //invert the busy signal
        IP = IP & 0x0F0;
        iMask = 0x08;
        for (i = 1; i<=IONum; i++) {
            iMask = iMask * 2;
        	}
        IP = IP & iMask;
        iBit = 0;
        if (IP != 0) {
            iBit = 1;
        	}
    	}
        return(iBit);

}

// The WriteAllDOP function sets or resets the four digital outputs
// according to the value of "DOValue"
// DOValue can have the values 0 to 15
// if the value of DOValue is out of range
// "IErr" is set to non-zero.
//
// Note the Function InitPrinterPort must be called at the
// start of the program before this function can be used
void __fastcall TModDas005::WriteDOPs_DAS005(int DOValue)
{
    iErr = 0;
    if ((DOValue < 0) | (DOValue > 15)) {
        iErr = 1;
        }
    
    if (iErr == 0) {
        DataReg = DOValue;
        Out32(LPTData, DataReg);
        ControlReg = ControlReg & 0x0FE;       //bring strobe low then high */
        Out32(LPTControl, ControlReg);
        ControlReg = ControlReg | 0x01;
        Out32(LPTControl, ControlReg);
    	}
}

void __fastcall TModDas005::WriteDOP_DAS005(int State, int IONum)
{
// The WriteDOP function sets or resets a single output "IONum"
// according to the value in "State".
// IONum can have the values 1 to 4
// State can be 0 or 1.
// if the value of State or IONum are out of the above ranges
// "IErr" is set to non-zero.
//
// Note the Function InitPrinterPort must be called at the
// start of the program before this function can be used
int iMask, i;
    iErr = 0;
    if ((State != 0) & (State != 1)) {
        iErr = 1;
    	}
    if ((IONum < 1) | (IONum > 4)) {
        iErr = 1;
        }

    if (iErr == 0) {
        iMask = 0x01;
        for (i = 1; i<=IONum - 1; i++) {
            iMask = iMask * 2;
            }
        if (State == 0) {
            iMask = iMask ^ 0xffff;
            DataReg = DataReg & iMask;
            }
        else {
            DataReg = DataReg | iMask;
            }

        Out32(LPTData, DataReg);
        ControlReg = ControlReg & 0x0FE;       //bring strobe low then high */
        Out32(LPTControl, ControlReg);
        ControlReg = ControlReg | 0x01;
        Out32(LPTControl, ControlReg);
		}

}


void __fastcall TModDas005::InitDAQ_DAS005()
{
//Procedure which defines number of analog & digital inputs, outputs
    NUM_AIP = 8;
    NUM_AOP = 0;
    NUM_DIP = 4;
    NUM_DOP = 4;
    strcpy(DAQNAME,"DAS005");

}

void __fastcall TModDas005::Out32(int PortAddress, int Control)
{
Word PA;
char DVal;

    //Write a byte to a port.}
    PA=(Word)PortAddress;
    DVal=(char)Control;
    OutPort(PA,DVal);


}

byte __fastcall TModDas005::Inp32(int PortAddress)
{
Word PA;
DWORD iVal;
int i;

    PA=(Word)PortAddress;
    i=(int)InPort(PA);

    return(i);
}



