//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Das005.h"
#include "PrinterPort.h"
#include "Das005.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPrinterAddr *PrinterAddr;
//---------------------------------------------------------------------------
__fastcall TPrinterAddr::TPrinterAddr(TComponent* Owner)
    : TForm(Owner)
{
}


 int EcrAddress, EcrData;
 int PortBaseAddress;
 char PortMode[20], PortType[20];
 int PortCurrMode;



char* __fastcall TPrinterAddr::GetEcpModeDescription(int EcpModeValue)
{
char ss[30];
     switch (EcpModeValue) {
          case 0: strcpy(ss,"SPP");
          case 1: strcpy(ss,"PS/2");
          case 2: strcpy(ss,"Fast Centronics");
          case 3: strcpy(ss,"ECP");
          case 4: strcpy(ss,"EPP");
          case 6: strcpy(ss,"Test");
          case 7: strcpy(ss,"Configuration");
          }
     return(ss);

}


int __fastcall TPrinterAddr::ReadEcpMode(int TestAddress)
{
     //The Ecr mode is in bits 5, 6, and 7 of the ECR.
     EcrAddress = TestAddress + 0x0402;
     EcrData = ModDas005->Inp32(EcrAddress);
     return((EcrData & 0x0E0) / 0x020);
}

int __fastcall TPrinterAddr::ReadEppTimeoutBit(int PortBaseAddress)
//Reads and clears the EPP timeout bit (status port bit 0).
//Should be done after each EPP operation.
//The method for clearing the bit varies, so try 3 ways: Do
{
   int StatusPortAddress;
   int ReadAgain,iBit;

//
// 1. Write 1 to it.}
// 2. Write 0 to it.}
// 3. Read it again.}
    StatusPortAddress = PortBaseAddress + 1;
    iBit = BitRead(StatusPortRead(PortBaseAddress), 0);
    ModDas005->Out32(StatusPortAddress, 1);
    ModDas005->Out32(StatusPortAddress, 0);
    ReadAgain = BitRead(StatusPortRead(PortBaseAddress), 0);
    return(iBit);
}

void __fastcall TPrinterAddr::SetEcpMode(int EcpModeValue)
{
     //Store the Ecp mode"s value and description in the Port array.
     //Port(IndexOfSelectedPort).EcpModeValue = EcpModeValue
     //Port(IndexOfSelectedPort).EcpModeDescription = GetEcpModeDescription(EcpModeValue)
     EcrAddress = PortBaseAddress + 0x0402;
     //Read the ECR + clear bits 5, 6, 7.
     EcrData = ModDas005->Inp32(EcrAddress) & 0x1F;
     //Write the selected value to bits 5, 6, 7.
     EcrData = EcrData + EcpModeValue * 0x20;
     ModDas005->Out32(EcrAddress, EcrData);
}


bool __fastcall TPrinterAddr::TestForEcp(int TestAddress)
{
 bool iBit;
 int EcrBit0;
 int EcrBit1;
 int ControlBit0;
 int ControlBit1;
 int ControlPortData;
 int TestEcrAddress;
 int OriginalEcrData;


//Test for the presence of an ECP. Do}
//if the ECP is idle and the FIFO empty,
//in the ECP"s Ecr (at Base Address+402h),
//bit 1(Fifo full)=0, and bit 0(Fifo empty)=1.

//The first test is to see if these bits differ from the

//corresponding bits in the control port (at Base Address+2).
//if so, a further test is to write 34h to the Ecr,

//then read it back. Bit 1 is read/write, and bit 0 is read-only.
//if the value read is 35h, the port is an ECP.

    iBit = False;
    EcrAddress = TestAddress + 0x0402;

    //Read ECR bits 0 + 1 and Control Port bit 1
    EcrData = ModDas005->Inp32(EcrAddress);
    EcrBit0 = BitRead(EcrData, 0);
    EcrBit1 = BitRead(EcrData, 1);
    ControlPortData = ControlPortRead(TestAddress);
    ControlBit1 = BitRead(ControlPortData, 1);
    if ((EcrBit0 == 1) && (EcrBit1 == 0))
       {
       //Compare control bit 1 to ECR bit 1.}
       //Toggle the control bit if necessary,}
       //to be sure the two registers are different.}
       if (ControlBit1 == 0)
          {
          ControlPortWrite(TestAddress, 0x0F);
          ControlPortData = ControlPortRead(TestAddress);
          ControlBit1 = BitRead(ControlPortData, 1);
          }
       if (EcrBit1 != ControlBit1)
          {
          OriginalEcrData = EcrData;
          ModDas005->Out32( EcrAddress, 0x034);
          EcrData = ModDas005->Inp32(EcrAddress);
          if (EcrData == 0x035)
             {
             iBit = True;
             }
         //Restore the ECR to its original value.}
         ModDas005->Out32( EcrAddress, OriginalEcrData);
         }
       }
     return(iBit);
}

bool __fastcall TPrinterAddr::TestForEpp(int TestAddress)
{
    int iBit;
    int ByteRead;
    int StatusPortData;
    int EppAddressPort;
    int TimeoutBit;
    int StatusPortAddress;


    //Write to an Epp register,) read it back.}
    //if the reads match the writes, it"s probably an Epp.}
    StatusPortAddress = TestAddress + 1;
    iBit = False;
    //Use EppAddressPort for testing. Do}
    //SPPs, ECPs, and PS/2 ports don"t have this register.}
    EppAddressPort = TestAddress + 3;
    ModDas005->Out32( EppAddressPort, 0x055);
    //Clear the timeout bit after each EPP operation.}
    TimeoutBit = ReadEppTimeoutBit(TestAddress);
    ByteRead = ModDas005->Inp32(EppAddressPort);
    TimeoutBit = ReadEppTimeoutBit(TestAddress);
    if (ByteRead == 0x055)
        {
        ModDas005->Out32( EppAddressPort, 0x0AA);
        TimeoutBit = ReadEppTimeoutBit(TestAddress);
        ByteRead = ModDas005->Inp32(EppAddressPort);
        TimeoutBit = ReadEppTimeoutBit(TestAddress);
        if (ByteRead == 0x0AA)
            {
            iBit = True;
            }
        }
    return(iBit);
}

bool __fastcall TPrinterAddr::TestForPS2(int TestAddress)
{
    bool iBit;
    int DataInput;
    int ControlPortData;
    int OriginalControlPortData;
    int OriginalDataPortData;

//
//Tests a parallel port"s data port for bidirectional ability. Do}
//First, try to tri-state (disable) the data outputs by}
//setting bit 5 of the Control port.}
// write 2 values to the data port and read each back}
//if (the values match, the data outputs are not disabled,}

//and the port is not bidirectional.}
//if (the values don"t match,}

//the data outputs are disabled and the port is bidirectional.}

//Set Control port bit 5.}
     ControlPortWrite( TestAddress, 0x02F);
     iBit = False;
     //Write the first byte and read it back:}
     DataPortWrite(TestAddress, 0x055);
     DataInput = DataPortRead(TestAddress);
     //if (it doesn"t match, the port is bidirectional.}

     if (!(DataInput == 0x055)) iBit = True;

     //if (it matches, write another and read it back.}

     if (DataInput == 0x055)
         {
         DataPortWrite(TestAddress, 0x0AA);
         DataInput = DataPortRead(TestAddress);
         //if (it doesn"t match, the port is bidirectional}
         if ( DataInput != 0x0AA)
             {
             iBit = True;
             }
         }
         //Reset Control port bit 5}
     ControlPortWrite(TestAddress, 0x0F);
     return(iBit);
}

bool __fastcall TPrinterAddr::TestForSpp(int TestAddress)
{
bool iBit;
int ByteRead;
//Write two bytes and read them back.}
//if (the reads match the writes, the port exists.}


//Be sure that control port bit 5 = 0 (data outputs enabled).}
    ControlPortWrite(TestAddress, 0x0F);
    iBit = False;
    DataPortWrite(TestAddress, 0x055);
    ByteRead = DataPortRead(TestAddress);
    if (ByteRead == 0x055)
        {
        DataPortWrite(TestAddress, 0x0AA);
        ByteRead = DataPortRead(TestAddress);
        if (ByteRead == 0x0AA)
            {
            iBit = True;
            }
        }
    return(iBit);
}

bool __fastcall TPrinterAddr::TestPort(int TestAddress)
{
char  EcpModeDescription[20];
int EcpModeValue;
bool EcpExists, EppExists, SppExists, PS2Exists, bBit;

//Test for a port"s presence, and if (it exists, the type of port. Do}
//In order, check for the presence of an ECP, EPP, SPP, and PS/2 port. Do}

//Update the information in the Port array  and the display.}
    bBit = False;
    EcpExists = False;
    EppExists = False;
    SppExists = False;
    PS2Exists = False;
    strcpy(PortType, "");
    strcpy(PortMode, "");
    //TestAddress = Port(PortIndex).Address}
    // by hiding all port details.}

    EcpExists = TestForEcp(TestAddress);
    if (EcpExists)
        {
        strcpy(PortType, "ECP");
        //Read the current Ecp mode.}
        EcpModeValue = ReadEcpMode(TestAddress);
        strcpy(PortMode, GetEcpModeDescription(EcpModeValue));
        }
    else
        //if (it"s not an ECP, look for an EPP. Do}
        {
        //if (TestAddress = 3BCh, skip the EPP test.}
        //EPPs aren"t allowed at 3BCh due to possible conflict}
        //with video memory.}
        if (TestAddress == 0x03BC)
            {
            EppExists = False;
            }
        else;
            EppExists = TestForEpp(TestAddress);
        }
    if (EppExists)
        {
        strcpy(PortType, "EPP");
        }
    else
        //if (it"s not an EPP, look for an SPP. Do}
        {
        SppExists = TestForSpp(TestAddress);
        if (SppExists)
            {
            //Test for a PS/2 port only if (the SPP exists Do}
            //(because if (the port doesn"t exist, it will pass the PS/2 test!)}
            PS2Exists = TestForPS2(TestAddress);
            if (PS2Exists)
                {
                strcpy(PortType,"PS/2");
                }
            else
                {
                strcpy(PortType,"SPP");
                }
            }
        else
            {
            strcpy(PortType,"");
            }
        }

    if (PortType != "")
        {
        bBit = True;
        }
    return(bBit);
}



int __fastcall TPrinterAddr::BitRead(int Variable, int BitNumber)
{
int i,BitValue;

     //Returns the value (0 or 1) of the requested bit in a Variable.}
     BitValue=1;
     for (i=1;i<=BitNumber;i++)
         {
         BitValue=BitValue*2;
         }
     i = (Variable & BitValue) / BitValue;
     return(i);
}

int __fastcall TPrinterAddr::StatusPortRead(int PortBaseAddress)
{
int i;
//Reads a parallel port"s status port.}
//Calculates the status-port address from the port"s}
//base address, and inverts bit 7 of the byte read.}
//The status-port hardware reinverts these bits,}
//so the value read matches the value at the connector.}
    i = (ModDas005->Inp32(PortBaseAddress + 1) ^ 0x080);
    return(i);
}


int __fastcall TPrinterAddr::ControlPortRead(int PortBaseAddress)
{
int i;
//Reads a parallel port"s control port.}
//Calculates the control-port address from the port"s}
//base address, and inverts bits 0, 1, + 3 of the byte read.}
//The control-port hardware reinverts these bits,}
//so the value read matches the value at the connector.}
    i = (ModDas005->Inp32(PortBaseAddress + 2) ^ 0x0B);
    return(i);

}

void __fastcall TPrinterAddr::ControlPortWrite(int PortBaseAddress, int Value)
{
//Writes a Value to a parallel port"s control port.}
//Calculates the control-port address from the port"s}
//base address, and inverts bits 0, 1, + 3.}
//The control-port hardware reinverts these bits,}
//so Value is written to the port connector.}
	ModDas005->Out32( PortBaseAddress + 2, Value ^ 0x0B);
}

void __fastcall TPrinterAddr::DataPortWrite(int PortBaseAddress, int Value)
{
//Writes a byte to a parallel port"s data port.}
   ModDas005->Out32( PortBaseAddress, Value);
}



int __fastcall TPrinterAddr::DataPortRead(int PortBaseAddress)
{
int i;
    //Reads a parallel port"s data port.}
    i = ModDas005->Inp32(PortBaseAddress);
    return(i);
}


void __fastcall TPrinterAddr::cmdExitClick(TObject *Sender)
{
    ModDas005->LptPortAddr = PortBaseAddress;   //
    PrinterAddr->Close();

}
//---------------------------------------------------------------------------

void __fastcall TPrinterAddr::FormShow(TObject *Sender)
{
    if (ModDas005->LPTNo == 1)
        {
        OptLpt1->Checked = true;
        }
    if (ModDas005->LPTNo == 2)
        {
        OptLpt2->Checked = True;
        }
    if (ModDas005->LPTNo == 0)
        {
        OptLpt3->Checked = True;
        TxtAddress->Text = IntToHex(ModDas005->LptPortAddr,4);
        }
    TxtTypePort->Text = PortType;
    TxtMode->Text = PortMode;

}
//---------------------------------------------------------------------------

void __fastcall TPrinterAddr::cmdFindPrinterPortClick(TObject *Sender)
{
 AnsiString sStr;
 bool TP;
    if (OptLpt1->Checked!= False) {
        ModDas005->LPTNo = 1;
        PortBaseAddress = 0x0378;
        }
    if (OptLpt2->Checked != False) {
        ModDas005->LPTNo = 2;
        PortBaseAddress = 0x0278;
        }
    if (OptLpt3->Checked != False) {
        ModDas005->LPTNo = 0;
        sStr= "$"+ TxtAddress->Text;
        PortBaseAddress = StrToInt(sStr);
        }
    TP = TestPort(PortBaseAddress);
    if (TP == True)
        {
        TxtTypePort->Text = PortType;
        TxtMode->Text = PortMode;

        }
    else
        {
        TxtTypePort->Text = "Not Found";
        TxtMode->Text = "";
        }

}
//---------------------------------------------------------------------------

void __fastcall TPrinterAddr::cmdSPPClick(TObject *Sender)
{

    if (PortType != "") {
        if (PortType == "ECP")
            {
            TxtMode->Text = "SPP";
            SetEcpMode(0); 		//Set it to SPP
            }
        ModDas005->InitPrinterPort(ModDas005->LPTNo, ModDas005->LptPortAddr);
        ShowMessage( "Printer Port Initialised");
    }

}
//---------------------------------------------------------------------------

