//---------------------------------------------------------------------------
#ifndef PrinterPortH
#define PrinterPortH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TPrinterAddr : public TForm
{
__published:	// IDE-managed Components
    TGroupBox *GroupBox1;
    TRadioButton *OptLpt1;
    TRadioButton *OptLpt2;
    TRadioButton *OptLpt3;
    TEdit *TxtAddress;
    TLabel *Label1;
    TEdit *TxtTypePort;
    TLabel *Label2;
    TEdit *TxtMode;
    TButton *cmdExit;
    TButton *cmdFindPrinterPort;
    TButton *cmdSPP;
    
    
    void __fastcall cmdExitClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall cmdFindPrinterPortClick(TObject *Sender);
    void __fastcall cmdSPPClick(TObject *Sender);
    
private:	// User declarations
public:		// User declarations
    __fastcall TPrinterAddr(TComponent* Owner);
    bool __fastcall TestPort(int TestAddress);
    char* __fastcall GetEcpModeDescription(int EcpModeValue);
    void __fastcall SetEcpMode(int EcpModeValue);
    int __fastcall ReadEcpMode(int TestAddress);
    int __fastcall ReadEppTimeoutBit(int PortBaseAddress);
    int __fastcall BitRead(int Variable, int BitNumber);
    int __fastcall StatusPortRead(int PortBaseAddress);
    bool __fastcall TestForEcp(int TestAddress);
    int __fastcall ControlPortRead(int PortBaseAddress);
    void __fastcall ControlPortWrite(int PortBaseAddress, int Value);
    bool __fastcall TestForEpp(int TestAddress);
    bool __fastcall TestForPS2(int TestAddress);
    int __fastcall DataPortRead(int PortBaseAddress);
    void __fastcall DataPortWrite(int PortBaseAddress, int Value);
    bool __fastcall TestForSpp(int TestAddress);

};
//---------------------------------------------------------------------------
extern PACKAGE TPrinterAddr *PrinterAddr;
//---------------------------------------------------------------------------
#endif
